class Wikian
  class WikianGetError < StandardError; end
  class MissingSearchTermError < WikianGetError; end

  class Search < Subcommand
    def initialize(args)
      super

      srsearch =  non_opt_args.join(' ')

      raise MissingSearchTermError if srsearch.empty?

      @params.merge!('srsearch' => srsearch, 'format' => Wikian::RESPONSE_FORMAT)

      @output_file = srsearch

      @query = @params.to_query

      @api_url = URI("https://#{config['meta']['site']}/w/api.php?#{query}")
    rescue => e
      puts "#{e.class} in #{__FILE__}", e.message
      exit
    end

    def template
      <<~eos
        # for a list of parameters to use here see: https://www.mediawiki.org/wiki/API:Search
        meta:
          site: en.wikipedia.org
          headers:
            user-agent: Wikian
        api:
          action:
            - query
          list:
            - search
          #srsearch: # text to search for. You can use multiple
          #  - Mr. Fixit
          #  - Term 2
      eos
    end
  end
end
